unit Unit1;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    Db, DBTables, Grids, DBGrids, ExtCtrls, DBCtrls, StdCtrls, ExRxDBGrid,
    RXDBCtrl, RXCombos;

type
    TForm1 = class(TForm)
        DBNavigator1: TDBNavigator;
        Table1: TTable;
        DataSource1: TDataSource;
        Panel1: TPanel;
        ExRxDBGrid1: TExRxDBGrid;
        CheckBox1: TCheckBox;
        CheckBox2: TCheckBox;
        CheckBox3: TCheckBox;
        CheckBox4: TCheckBox;
        Button1: TButton;
        Button2: TButton;
        Button3: TButton;
        Button4: TButton;
        Button5: TButton;
        Button6: TButton;
        Panel2: TPanel;
        Panel3: TPanel;
        Button7: TButton;
        Button9: TButton;
        Button10: TButton;
        Button8: TButton;
        Button12: TButton;
        Button11: TButton;
        Label1: TLabel;
        ColorComboBox1: TColorComboBox;
        Label2: TLabel;
        ColorComboBox2: TColorComboBox;
        Label3: TLabel;
        ColorComboBox3: TColorComboBox;
        procedure CheckBox1Click(Sender: TObject);
        procedure CheckBox2Click(Sender: TObject);
        procedure CheckBox3Click(Sender: TObject);
        procedure CheckBox4Click(Sender: TObject);
        procedure Button1Click(Sender: TObject);
        procedure Button2Click(Sender: TObject);
        procedure Button3Click(Sender: TObject);
        procedure ExRxDBGrid1ApplyCellAttribute(Sender: TObject; Field: TField; Canvas: TCanvas; State: TGridDrawState);
        procedure Button4Click(Sender: TObject);
        procedure FormCreate(Sender: TObject);
        procedure Button5Click(Sender: TObject);
        procedure Button6Click(Sender: TObject);
        procedure Button7Click(Sender: TObject);
        procedure Button8Click(Sender: TObject);
        procedure Button9Click(Sender: TObject);
        procedure ExRxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
        procedure Button10Click(Sender: TObject);
        procedure Button12Click(Sender: TObject);
        procedure ColorComboBox1Change(Sender: TObject);
        procedure Button11Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

var
    Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
    ExRxDBGrid1.Perform(wm_Paint, 0, 0);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    ExRxDBGrid1.DisplayBoolean := not ExRxDBGrid1.DisplayBoolean;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
    ExRxDBGrid1.DisplayImages := not ExRxDBGrid1.DisplayImages;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
    ExRxDBGrid1.DisplayMemo := not ExRxDBGrid1.DisplayMemo;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
    ExRxDBGrid1.RowSizingAllowed := not ExRxDBGrid1.RowSizingAllowed;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if Button1.Caption = 'Autosize Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.GridAutoSize := True;
            Table1.EnableControls;
            Button1.Caption := 'Autosize On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.GridAutoSize := False;
            Table1.EnableControls;
            Button1.Caption := 'Autosize Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if Button2.Caption = 'FullSizeMemo Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.FullSizeMemo := True;
            Table1.EnableControls;
            Button2.Caption := 'FullSizeMemo On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.FullSizeMemo := False;
            Table1.EnableControls;
            Button2.Caption := 'FullSizeMemo Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if Button3.Caption = 'FlatStyle On' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.Cells3D := True;
            Table1.EnableControls;
            Button3.Caption := 'Cells3D On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.Cells3D := False;
            Table1.EnableControls;
            Button3.Caption := 'FlatStyle On'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.ExRxDBGrid1ApplyCellAttribute(Sender: TObject;
    Field: TField; Canvas: TCanvas; State: TGridDrawState);
begin
    if Field = Table1.Fields[0] then
        if not (gdSelected in State) then
            Canvas.Font.Color := clBlue;

    if Field = Table1.Fields[1] then
        if not (gdSelected in State) then
            Canvas.Font.Color := clRed;

    if Field = Table1.Fields[2] then
        Canvas.Font.Style := Canvas.Font.Style + [fsBold];

    if Field = Table1.Fields[3] then
        if not (gdSelected in State) then
            begin
                Canvas.Brush.Style := bsSolid;
                Canvas.Brush.Color := clGreen;
            end;

    if Field = Table1.Fields[4] then
        if Table1.Fields[4].AsInteger > 30 then
            if not (gdSelected in State) then
                Canvas.Font.Color := clYellow;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    if Button4.Caption = 'OptWidth Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.Align := alNone;
            ExRxDBGrid1.Width := ExRxDBGrid1.OptWidth;
            Table1.EnableControls;
            Button4.Caption := 'OptWidth On';
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.Align := alClient;
            Table1.EnableControls;
            Button4.Caption := 'OptWidth Off';
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    if Button5.Caption = 'CellHints Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.CellHints := True;
            Table1.EnableControls;
            Button5.Caption := 'CellHints On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.CellHints := False;
            Table1.EnableControls;
            Button5.Caption := 'CellHints Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    if Button6.Caption = 'UseRowColors Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.UseRowColors := True;
            Table1.EnableControls;
            Button6.Caption := 'UseRowColors On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.UseRowColors := False;
            Table1.EnableControls;
            Button6.Caption := 'UseRowColors Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    if Button7.Caption = 'MultiLineTitles Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.MultiLineTitles := True;
            Table1.EnableControls;
            Button7.Caption := 'MultiLineTitles On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.MultiLineTitles := False;
            Table1.EnableControls;
            Button7.Caption := 'MultiLineTitles Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
    if Button8.Caption = 'UseBackgroundPicture Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.UseBackgroundPicture := True;
            Table1.EnableControls;
            Button8.Caption := 'UseBackgroundPicture On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.UseBackgroundPicture := False;
            Table1.EnableControls;
            Button8.Caption := 'UseBackgroundPicture Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
    if Button9.Caption = 'AutoWidth Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.GridAutoWidth := True;
            Table1.EnableControls;
            Button9.Caption := 'AutoWidth On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.GridAutoWidth := False;
            Table1.EnableControls;
            Button9.Caption := 'AutoWidth Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.ExRxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
    State: TGridDrawState);
begin
    if gdFocused in State then
        begin
            Panel2.Caption := 'Cell [Col, Row] = ' + Format('%d, %d', [ExRxDBGrid1.Col, ExRxDBGrid1.Row])
                + '  TopRow = ' + IntToStr(ExRxDBGrid1.TopRow)
                + '  LeftCol = ' + IntToStr(ExRxDBGrid1.LeftCol)
                + '  FixedCols = ' + IntToStr(ExRxDBGrid1.FixedCols)
                + '  FixedRows = ' + IntToStr(ExRxDBGrid1.FixedRows)
                + '  ColCount = ' + IntToStr(ExRxDBGrid1.ColCount)
                + '  RowCount = ' + IntToStr(ExRxDBGrid1.RowCount);

            Panel3.Caption := 'VisibleColCount = ' + IntToStr(ExRxDBGrid1.VisibleColCount)
                + '  VisibleRowCount = ' + IntToStr(ExRxDBGrid1.VisibleRowCount)
                + '  GridHeight = ' + IntToStr(ExRxDBGrid1.GridHeight)
                + '  GridWidth = ' + IntToStr(ExRxDBGrid1.GridWidth)
                + '  Height = ' + IntToStr(ExRxDBGrid1.Height)
                + '  Width = ' + IntToStr(ExRxDBGrid1.Width);
        end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
    if Assigned(ExRxDBGrid1.OnApplyCellAttribute) then
        begin
            ExRxDBGrid1.OnApplyCellAttribute := nil;
            ExRxDBGrid1.SetFocus;
            ExRxDBGrid1.Invalidate;
        end
    else
        begin
            ExRxDBGrid1.OnApplyCellAttribute := ExRxDBGrid1ApplyCellAttribute;
            ExRxDBGrid1.SetFocus;
            ExRxDBGrid1.Invalidate;
        end;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
    ExRxDBGrid1.ExportGrid(ExtractFilePath(Application.ExeName) + 'Test.Dat');
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
    if Button11.Caption = 'DrawFocusRect Off' then
        begin
            Table1.DisableControls;
            ExRxDBGrid1.DrawFocusRect := True;
            Table1.EnableControls;
            Button11.Caption := 'DrawFocusRect On'
        end
    else
        begin
            Table1.DisableControls;
            ExRxDBGrid1.DrawFocusRect := False;
            Table1.EnableControls;
            Button11.Caption := 'DrawFocusRect Off'
        end;
    ExRxDBGrid1.SetFocus;
end;

procedure TForm1.ColorComboBox1Change(Sender: TObject);
begin
    ExRxDBGrid1.HighlightColor := ColorComboBox1.ColorValue;
    ExRxDBGrid1.ImageHighlightColor := ColorComboBox2.ColorValue;
    ExRxDBGrid1.HighlightFontColor := ColorComboBox3.ColorValue;
    ExRxDBGrid1.SetFocus;
end;

end.

